#ifndef PQ_H
#define PQ_H

#include <stdint.h>

typedef struct priority_queue priority_queue;

#ifndef TEST

// NEEDS TO BE DEFINED ------------------------------------- 
//#define BETTER(a, b)
//#define SET(a, b)
//#define PQnode node*

typedef struct node {
    float heur; // heuristic. Sort heap based on this value
    int data;
} node;
#define BETTER(a, b) (a.heur < b.heur)
#define SET(a, b)
#define PQnode node
#define pqnode_destroy(a)

// --------------------------------------------------------
#else
#ifdef TEST_DIRECT
#define PQnode float
#define BETTER(a, b) (a < b)
#define SET(a, b) a = b
#define pqnode_destroy(a)
#define HEUR(a) a
#endif
#ifdef TEST_PTR
typedef struct node {
    float heur; // heuristic. Sort heap based on this value
    int data;
} node;
#define PQnode node*
#define BETTER(a, b) (a->heur > b->heur)
#define SET(a, b) a = b
#define pqnode_destroy(a) free(a)
#define HEUR(a) a->heur
#endif

void pq_print(priority_queue *PQ);

#endif

#define SWAP(a, b, scratch) SET(scratch, a); SET(a, b); SET(b, scratch)
#define heap PQ->h

// priority queue implemented with an array-based binary heap. 
struct priority_queue {
    // number of elements in priority queue. 
    // Also, index of the next empty element in the array.
    int size;
    int max_size;
    PQnode *h; // heap is an array of PQnodes
};

void pq_push(priority_queue *PQ, PQnode new_node);
PQnode pq_pop(priority_queue *PQ);
priority_queue* pq_create(int initial_max_size);
priority_queue* pq_from_array(PQnode *array, int array_size); 
void pq_destroy(priority_queue *PQ);

#endif
